# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}


%define section free
%define namedversion 2.0.0-M4
%define with_serial 0

Summary:        A Multipurpose Infrastructure for Network Applications
Name:           mina
Version:        2.0.0
Release:        0.M4.1%{?dist}
Epoch:          0
Group:          System/Networking
License:        Apache 2.0 License
URL:            http://directory.apache.org/subprojects/mina/
Source0:        %{name}-%{namedversion}.tar.gz
# svn export http://svn.apache.org/repos/asf/mina/tags/2.0.0-M4/ mina-2.0.0

Source1:        directory-pom-1.0.4.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        %{name}-settings.xml
Patch0:         mina-logging-MdcInjectionFilterTest.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel = 0:1.5.0
BuildRequires:  ant >= 0:1.6.5
BuildRequires:  ant-contrib >= 0:1.0-0.b3
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-default-skin
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-project-info-reports
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-jxr
BuildRequires:  maven-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  felix-maven2
BuildRequires:  mojo-maven2-plugin-build-helper
BuildRequires:  mojo-maven2-plugin-rat

BuildRequires:  easymock2
BuildRequires:  easymock-classextension2
#BuildRequires:  ivy
BuildRequires:  javassist >= 0:3.6
BuildRequires:  jakarta-commons-lang
BuildRequires:  jmock
#BuildRequires:  junit
BuildRequires:  junit4
BuildRequires:  rmock
%if %{with_serial}
BuildRequires:  rxtx
%endif
#BuildRequires:  xpp3

#BuildRequires:  cglib
BuildRequires:  slf4j >= 0:1.5.0
BuildRequires:  tl-netty2
BuildRequires:  jzlib
BuildRequires:  log4j
BuildRequires:  ognl
BuildRequires:  qdox18
BuildRequires:  spring2-beans
BuildRequires:  spring2-context
BuildRequires:  spring2-core
BuildRequires:  tomcat5-server-lib
BuildRequires:  xbean

Requires:       java >= 0:1.5.0
Requires:       slf4j >= 0:1.5.0
Provides:       mina-filter-ssl = %{epoch}:%{version}-%{release}
Obsoletes:      mina-filter-ssl < %{epoch}:%{version}-%{release}

Requires(post):   jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
MINA (Multipurpose Infrastructure for Network Applications) is a
network application framework which helps users develop high
performance and high scalability network applications easily.

%package filter-codec-netty
Group:          System/Networking
Summary:        Netty2 filter for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       tl-netty2

%description filter-codec-netty
%{summary}.

%package filter-compression
Group:          System/Networking
Summary:        JZlib compression filter for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jzlib

%description filter-compression
%{summary}.

%package integration-beans
Group:          System/Networking
Summary:        Beans integration for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description integration-beans
%{summary}.

%package integration-jmx
Group:          System/Networking
Summary:        JMX integration for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-integration-beans = %{epoch}:%{version}-%{release}
Requires:       %{name}-integration-ognl = %{epoch}:%{version}-%{release}

%description integration-jmx
%{summary}.

%package integration-ognl
Group:          System/Networking
Summary:        OGNL integration for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-integration-beans = %{epoch}:%{version}-%{release}
Requires:       ognl

%description integration-ognl
%{summary}.

%package integration-xbean
Group:          System/Networking
Summary:        XBean integration for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-integration-beans = %{epoch}:%{version}-%{release}
Requires:       spring2-all
Requires:       xbean

%description integration-xbean
%{summary}.

%package statemachine
Group:          System/Networking
Summary:        Statemachine for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description statemachine
%{summary}.

%package transport-apr
Group:          System/Networking
Summary:        APR transport for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       tomcat5-server-lib

%description transport-apr
%{summary}.

%if %{with_serial}
%package transport-serial
Group:          System/Networking
Summary:        Serial transport for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       rxtx

%description transport-serial
%{summary}.
%endif

%package demo
Group:          System/Networking
Summary:        Examples for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       %{name}-statemachine = %{epoch}:%{version}-%{release}
Requires:       spring2-context

%description demo
%{summary}.

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
%{summary}.

%package manual
Group:          Development/Documentation
Summary:        Documents for %{name}

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}
%patch0 -b .sav0

%build
cp %{SOURCE3} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir -p m2_repo/repository/JPP/maven2/default_poms
cp %{SOURCE1} m2_repo/repository/JPP/maven2/default_poms/org.apache.directory-build.pom
cp pom.xml m2_repo/repository/JPP/maven2/default_poms/org.apache.mina-build.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export JAVA_HOME=%{_jvmdir}/java-1.5.0


export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
export MAVEN_OPTS="-Dmaven.repo.local=$MAVEN_REPO_LOCAL -Dmaven2.jpp.mode=true -Dmaven.test.failure.ignore=true -Djava.awt.headless=true"
mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        install 

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        javadoc:javadoc

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -N \
        site


%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-build.pom
%add_to_maven_depmap org.apache.mina build %{version} JPP/mina build

install -m 644 core/target/%{name}-core-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 core/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-core.pom
%add_to_maven_depmap org.apache.mina mina-core %{namedversion} JPP/mina core

install -m 644 filter-codec-netty/target/%{name}-filter-codec-netty-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-codec-netty-%{version}.jar
install -m 644 filter-codec-netty/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-filter-codec-netty.pom
%add_to_maven_depmap org.apache.mina mina-filter-codec-netty %{namedversion} JPP/mina filter-codec-netty

install -m 644 filter-compression/target/%{name}-filter-compression-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/filter-compression-%{version}.jar
install -m 644 filter-compression/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-filter-compression.pom
%add_to_maven_depmap org.apache.mina mina-filter-compression %{namedversion} JPP/mina filter-compression

install -m 644 example/target/%{name}-example-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/example-%{version}.jar
install -m 644 example/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-example.pom
%add_to_maven_depmap org.apache.mina mina-example %{namedversion} JPP/mina example

install -m 644 integration-beans/target/%{name}-integration-beans-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-beans-%{version}.jar
install -m 644 integration-beans/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-integration-beans.pom
%add_to_maven_depmap org.apache.mina mina-integration-beans %{namedversion} JPP/mina integration-beans

install -m 644 integration-jmx/target/%{name}-integration-jmx-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-jmx-%{version}.jar
install -m 644 integration-jmx/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-integration-jmx.pom
%add_to_maven_depmap org.apache.mina mina-integration-jmx %{namedversion} JPP/mina integration-jmx

install -m 644 integration-ognl/target/%{name}-integration-ognl-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-ognl-%{version}.jar
install -m 644 integration-ognl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-integration-ognl.pom
%add_to_maven_depmap org.apache.mina mina-integration-ognl %{namedversion} JPP/mina integration-ognl

install -m 644 integration-xbean/target/%{name}-integration-xbean-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/integration-xbean-%{version}.jar
install -m 644 integration-xbean/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-integration-xbean.pom
%add_to_maven_depmap org.apache.mina mina-integration-xbean %{namedversion} JPP/mina integration-xbean

install -m 644 statemachine/target/%{name}-statemachine-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/statemachine-%{version}.jar
install -m 644 statemachine/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-statemachine.pom
%add_to_maven_depmap org.apache.mina mina-statemachine %{namedversion} JPP/mina statemachine

install -m 644 transport-apr/target/%{name}-transport-apr-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/transport-apr-%{version}.jar
install -m 644 transport-apr/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-transport-apr.pom
%add_to_maven_depmap org.apache.mina mina-transport-apr %{namedversion} JPP/mina transport-apr

%if %{with_serial}
install -m 644 transport-serial/target/%{name}-transport-serial-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/transport-serial-%{version}.jar
install -m 644 transport-serial/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.mina-transport-serial.pom
%add_to_maven_depmap org.apache.mina mina-transport-serial %{namedversion} JPP/mina transport-serial
%endif

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 0755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink
rm -rf target/site/apidocs*

# manual
install -d -m 0755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr target/site/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/
cp -p LICENSE.txt $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}/

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun
%update_maven_depmap
%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post filter-codec-netty
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun filter-codec-netty
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post filter-compression
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun filter-compression
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}/LICENSE.txt
%{_javadir}/%{name}/core*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core-%{version}.jar.*
%endif

%files filter-codec-netty
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/filter-codec-netty*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/filter-codec-netty-%{version}.jar.*
%endif

%files filter-compression
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/filter-compression*.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/filter-compression-%{version}.jar.*
%endif

%files integration-beans
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/integration-beans*.jar

%files integration-jmx
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/integration-jmx*.jar

%files integration-ognl
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/integration-ognl*.jar

%files integration-xbean
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/integration-xbean*.jar

%files statemachine
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/statemachine*.jar

%files transport-apr
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/transport-apr*.jar

%if %{with_serial}
%files transport-serial
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/transport-serial*.jar
%endif

%files demo
%defattr(0644,root,root,0755)
%{_javadir}/%{name}/example*.jar

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%{_docdir}/%{name}-%{version}

%changelog
* Tue Apr 07 2009 Ralph Apel <r.apel at r-apel.de> 0:2.0.0-0.M4.1.jpp5
- 2.0.0-M4

* Sat Jul 05 2008 Ralph Apel <r.apel at r-apel.de> 0:2.0.0-0.M1.1.jpp5
- 2.0.0

* Fri Jul 04 2008 Ralph Apel <r.apel at r-apel.de> 0:1.1.4-1.jpp5
- 1.1.4
- mina-java5 is dropped

* Fri Jun 06 2008 Ralph Apel <r.apel at r-apel.de> 0:1.0.2-1jpp
- 1.0.2

* Wed Oct 25 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-2jpp
- Fix macro

* Wed Oct 25 2006 Ralph Apel <r.apel at r-apel.de> 0:1.0.0-1jpp
- Update to 1.0.0 for apacheds
- Add --with java5 to build full release

* Sun Feb 12 2006 Ralph Apel <r.apel at r-apel.de> 0:0.8.0-1jpp
- First JPackage release.
